#include <services/services.h>
//#include <ezkitutilities.h>
#include <drivers/adi_dev.h>
#include <drivers/ppi/adi_ppi.h>


#define FrameNumRows 240
#define FrameNumCols 720
#define NUMROWS 525
#define NUMCOLS 858

#define NUM_BUFFERS_L1 2
#define NUM_BUFFERS_L2 3

#define NUM_TRANSFER 525

#define L2NUMROWS  5
#define MBROWS 5
#define MBCOLS 240
#define NUM_MB 6

#define TRANSFER_LENGTH  4

extern ADI_DEV_2D_BUFFER Buffer2D_IN[NUM_BUFFERS_L2];
extern ADI_DEV_2D_BUFFER Buffer2D_OUT[NUM_BUFFERS_L2];

extern unsigned char subFrame1[];
extern unsigned char subFrame2[];
extern unsigned char subFrame3[];
extern unsigned char subFrame4[];
extern unsigned char subFrame5[];
extern unsigned char subFrame6[];
extern unsigned char subFrame7[];
extern unsigned char subFrame8[];
extern unsigned char subFrame9[];
extern unsigned char subFrame10[];

extern volatile u8 ButtonPressed;
extern volatile unsigned int Counter;

void BufferL2toL1(ADI_DMA_2D_TRANSFER * L1_buffer,ADI_DMA_2D_TRANSFER * L2_buffer, ADI_DMA_STREAM_HANDLE* shandle );

void BufferL1toL2(ADI_DMA_2D_TRANSFER * L2_buffer,ADI_DMA_2D_TRANSFER * L1_buffer, ADI_DMA_STREAM_HANDLE* shandle );

void BufferL1toL1(ADI_DMA_2D_TRANSFER * L1_buffer_dest,ADI_DMA_2D_TRANSFER * L1_buffer_src, ADI_DMA_STREAM_HANDLE* shandle );
						
void BufferL2toL2(ADI_DMA_2D_TRANSFER * L2_buffer_dest,ADI_DMA_2D_TRANSFER * L2_buffer_src, ADI_DMA_STREAM_HANDLE* shandle);
